﻿namespace UltraGridCellCollSpan
{
    using System.Drawing;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    internal class MyCreationFilter : IUIElementCreationFilter
    {
        private int newWidth;

        private int GetNewWidth(int oldWidth, int additionalWidth)
        {
            if (this.newWidth == 0)
            {
                this.newWidth = oldWidth + additionalWidth;
            }

            return this.newWidth;
        }
        public void AfterCreateChildElements(UIElement parent)
        {
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            CellUIElement cellElement = parent as CellUIElement;
            if (cellElement != null)
            {
                UltraGridCell cell = cellElement.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                int cellColIndex = cell.Column.Index;
                if (cell.Value.ToString().Contains("*") &&
                    cellColIndex != cell.Column.Band.Columns.Count - 1)
                {
                    int nextCellWidth = cell.Row.Cells[cellColIndex].GetUIElement().Rect.Width;
                    int newWidth = this.GetNewWidth(cellElement.Rect.Width, nextCellWidth);
                    int height = cellElement.Rect.Height;
                    cellElement.Rect = new Rectangle(cellElement.Rect.X, cellElement.Rect.Y, newWidth, height);
                }

                if (cellColIndex != 0 &&
                    cell.Row.Cells[cellColIndex - 1].Value.ToString().Contains("*"))
                {
                    cellElement.Rect = new Rectangle(cellElement.Rect.X, cellElement.Rect.Y, 0, 0);
                    return true;
                }
            }

            return false;
        }
    }
}